clear all; clc;

working_dir = '/Users/Chad/Experiments/2017_EEG_AddOne_Williams/Analysis/NatureResults/Flynn Data';
cd(working_dir); %Change directory to where the data is
prefix = 'AddOne_flynn_ThetaPower_'; %End of the desired filename
prefix2 = 'AddOne_flynn_AlphaPower_';
filenames = dir(strcat(prefix,'*')); %Find all filenames Rest
filenames2 = dir(strcat(prefix2,'*'));

% p_rem = [1, 10, 26, 28];
% filenames(p_rem,:) = [];
% filenames2(p_rem,:) = [];

%Frequency band of interest
load_data = 0;
frex = [4:6];
frex2 = [11:12];
seg_length = 100;
%Individual = 1 means doing all frequencies individually from frex
%variable, 0 means average the frequencies in frex
Individual = 0;
pool = 1;
%elec_pool1 = {'AFz';'Fz';'FCz';'F1';'F2'};
elec_pool1 = {'FCz'};
elec_pool2 = {'Pz'};

if ~load_data
for subject_counter = 1:length(filenames)
    %Remove variables
    disp(num2str(subject_counter));
    subject_data = [];temp_data1 = [];temp_data2 = [];tempFFTData = [];tempFFT = [];
    SD = [];Avg = [];FzLoc = [];c_index = [];
    
    %Load subject Data
    for analysis_counter = 1:2
        subject_data = [];
        if analysis_counter == 1
            subject_data = importdata(filenames(subject_counter).name);
        else
            subject_data = importdata(filenames2(subject_counter).name);
        end
        
        elec_pool = [];
        if analysis_counter == 1
            elgth = length(elec_pool1);
            elec_pool = elec_pool1;
            if Individual
                flgth = length(frex);
            else
                flgth = 1;
            end
        else
            elgth = length(elec_pool2);
            elec_pool = elec_pool2;
            if Individual
                flgth = length(frex2);
            else
                flgth = 1;
            end
        end
        for frex_count = 1:flgth
            %Whether to do individual or averaged frequencies
            if Individual
                if analysis_counter == 1
                    freq = frex(frex_count);
                else
                    freq = frex2(frex_count);
                end
            else
                if analysis_counter == 1
                    freq = frex;
                else
                    freq = frex2;
                end
            end
            
            %Find electrode of interest
            c_index = [];
            for electrode_count = 1:elgth
                for chan_count = 1:62
                    if strmatch(subject_data.chanlocs(chan_count).labels,elec_pool{electrode_count,1},'exact');
                        FzLoc(chan_count) = 1;
                    else
                        FzLoc(chan_count) = 0;
                    end
                end
                c_index(electrode_count) = find(FzLoc == 1);
            end
            
            %Get AR checks
            tempAR = [];
            tempARbefore = [];
            tempARafter = [];
            for AR_count = 1:52
                tempAR(AR_count) = cell2mat(subject_data.FFT.nAccepted(AR_count)) /(cell2mat(subject_data.FFT.nAccepted(AR_count)) + cell2mat(subject_data.FFT.nRejected(AR_count)));
                tempARbefore(AR_count) = (cell2mat(subject_data.FFT.nAccepted(AR_count)) + cell2mat(subject_data.FFT.nRejected(AR_count)));
                tempARafter(AR_count) = (cell2mat(subject_data.FFT.nAccepted(AR_count)) + cell2mat(subject_data.FFT.nRejected(AR_count)))- cell2mat(subject_data.FFT.nRejected(AR_count));
            end
            
            AR(subject_counter,1) = sum(tempARbefore);
            AR(subject_counter,2) = sum(tempARafter);
            AR(subject_counter,3) = mean(tempAR);
            AR(subject_counter,4) = (1-mean(tempAR))*100;
            
            %Combine the data into continuous
            temp_data1 = [];
            temp_data2 = [];
            for cc = 1:26
                temp_data1 = [temp_data1; subject_data.FFT.data{cc}];
                temp_data2 = [temp_data2; subject_data.FFT.data{cc+26}];
            end
            
            for condition_counter = 1:26
                %Find frequency of interest for add-zero
                tempFFTData(1,condition_counter) = mean(mean(temp_data1(c_index+(62*(condition_counter-1)),freq)));
                
                %Find frequency of interest for add-one
                tempFFTData(2,condition_counter) = mean(mean(temp_data2(c_index+(62*(condition_counter-1)),freq)));
            end
            
            %Standardized
%             tFFTData = []; SD = []; Avg = []; tempFFT = [];
%             tempFFT = [tempFFTData(1,:) tempFFTData(2,:)];
%             SD = std(tempFFT);
%             Avg = mean(tempFFT);
%             tFFTData(:,1,analysis_counter) = (tempFFTData(1,:) - Avg)./SD;
%             tFFTData(:,2,analysis_counter) = (tempFFTData(2,:) - Avg)./SD;
%             tFFTData(:,3,analysis_counter) = tFFTData(:,2,analysis_counter) - tFFTData(:,1,analysis_counter);
%             %Unstandardized
              tFFTData(:,1,analysis_counter) = tempFFTData(1,:);
              tFFTData(:,2,analysis_counter) = tempFFTData(2,:);
              tFFTData(:,3,analysis_counter) = tFFTData(:,2,analysis_counter) - tFFTData(:,1,analysis_counter);
            
        end
        FFTData(subject_counter,:,:,analysis_counter) = tFFTData(:,:,analysis_counter);
    end
end
%FFTData(subject_counter,:,:,:) = squeeze(tFFTData);
%FFTData = squeeze(FFTData);
else
load('TA_FFTData.mat');
end


%Calculating CIs
for count = 1:2
    SEM1(count,:) = std(FFTData(:,:,1))/sqrt(29);
    SEM2(count,:) = std(FFTData(:,:,2))/sqrt(29);% Standard Error
    ts = tinv([0.05],28);      % T-Score
    CI1(count,:) = ts.*SEM1(count,:);
    CI2(count,:) = ts.*SEM2(count,:);
    
    SEM3(count,:) = std(FFTData(:,:,3))/sqrt(29);               % Standard Error
    CI3(count,:) = ts.*SEM3(count,:);
end

load('PupilMean.mat');
tick_colours = {'g','g','b','b','b','g','g','g','m','m','m','m','r','k','k','k','k','g','k','k','k','k','g','g','g','g'};
if Individual && ~pool
        %Plot Data for individual frequencies
    for plot_count = 1:length(frex)
        figure(1)
        subplot(length(frex),1,plot_count)
        plot(mean(FFTData(:,:,1,plot_count),1));
        hold on
        plot(mean(FFTData(:,:,2,plot_count),1));
        
        for count = 1:26
            hold on
            plot([count count],[-2 2], ':k');
        end
        xlab = {'Wait', 'Wait','Instr','Instr','Intr','Wait','Wait','Wait','Hear','Hear','Hear','Hear','Wait','Recall','Recall','Recall','Recall','Wait','Recall','Recall','Recall','Recall','Wait','Wait','Wait','Wait'};
        xticks([1:26]); set(gca,'XTickLabel',xlab); xlim([0 27]); leg = legend('Add Zero','Add One'); set(leg,'FontSize',16);
        figure(2)
        plot(mean(FFTData(:,:,3,plot_count),1));
        for count = 1:26
            hold on
            plot([count count],[-1 1], [':',tick_colours{count}]);
        end
        xlab = {'Wait', 'Wait','Instr','Instr','Intr','Wait','Wait','Wait','Hear','Hear','Hear','Hear','Wait','Recall','Recall','Recall','Recall','Wait','Recall','Recall','Recall','Recall','Wait','Wait','Wait','Wait'};
        xticks([1:26]); set(gca,'XTickLabel',xlab); xlim([0 27]);
    end
else
    figure(4)
    margins = [20, 20];
    %Plot 1 (Pupil Cond)
    subplot_tight(3,2,1,.06)
    plot(Pupil_Data(2,:));
    hold on
    plot(Pupil_Data(1,:));
    for count = 1:26
        hold on
        plot([count count],[-2 4], [':',tick_colours{count}]);
    end
    xlab = {'Wait', 'Wait','Instr','Instr','Intr','Wait','Wait','Wait','Hear','Hear','Hear','Hear','Wait','Recall','Recall','Recall','Recall','Wait','Recall','Recall','Recall','Recall','Wait','Wait','Wait','Wait'};
    xticks([1:26]); set(gca,'XTickLabel',xlab); xlim([0 27]); leg = legend('Add Zero','Add One'); set(leg,'FontSize',12); xtickangle(45);
    
    %Plot 2 (Pupil Diff)
    subplot_tight(3,2,2,.06)
    plot(Pupil_Data(3,:),'k');
    for count = 1:26
        hold on
        plot([count count],[-1 4], [':',tick_colours{count}]);
    end
    xlab = {'Wait', 'Wait','Instr','Instr','Intr','Wait','Wait','Wait','Hear','Hear','Hear','Hear','Wait','Recall','Recall','Recall','Recall','Wait','Recall','Recall','Recall','Recall','Wait','Wait','Wait','Wait'};
    xticks([1:26]); set(gca,'XTickLabel',xlab); xlim([0 27]); xtickangle(45);
    
    %Plot 3 (Theta Cond)
    subplot_tight(3,2,3,.06)
    plot(mean(FFTData(:,:,1,1),1),'b');
    hold on
    plot(mean(FFTData(:,:,2,1),1),'r');
    hold on
    for count = 1:26
        hold on
        plot([count count],[-1 1], [':',tick_colours{count}]);
    end
    xlab = {'Wait', 'Wait','Instr','Instr','Intr','Wait','Wait','Wait','Hear','Hear','Hear','Hear','Wait','Recall','Recall','Recall','Recall','Wait','Recall','Recall','Recall','Recall','Wait','Wait','Wait','Wait'};
    xticks([1:26]); set(gca,'XTickLabel',xlab); xlim([0 27]); leg = legend('Add Zero','Add One'); set(leg,'FontSize',12); xtickangle(45);
    
    %Plot 4 (Theta Diff)
    subplot_tight(3,2,4,.06)
    plot(mean(FFTData(:,:,3,1),1),'k');
    for count = 1:26
        hold on
        plot([count count],[-1 1], [':',tick_colours{count}]);
    end
    xlab = {'Wait', 'Wait','Instr','Instr','Intr','Wait','Wait','Wait','Hear','Hear','Hear','Hear','Wait','Recall','Recall','Recall','Recall','Wait','Recall','Recall','Recall','Recall','Wait','Wait','Wait','Wait'};
    xticks([1:26]); set(gca,'XTickLabel',xlab); xlim([0 27]); xtickangle(45);
    
    %Plot 5 (Alpha Cond)
    subplot_tight(3,2,5,.06)
    plot(mean(FFTData(:,:,1,2),1),'b');
    hold on
    plot(mean(FFTData(:,:,2,2),1),'r');
    hold on
    for count = 1:26
        hold on
        plot([count count],[-1 1], [':',tick_colours{count}]);
    end
    xlab = {'Wait', 'Wait','Instr','Instr','Intr','Wait','Wait','Wait','Hear','Hear','Hear','Hear','Wait','Recall','Recall','Recall','Recall','Wait','Recall','Recall','Recall','Recall','Wait','Wait','Wait','Wait'};
    xticks([1:26]); set(gca,'XTickLabel',xlab); xlim([0 27]); leg = legend('Add Zero','Add One'); set(leg,'FontSize',12); xtickangle(45);
    
    %Plot 6 (Alpha Diff)
    subplot_tight(3,2,6,.06)
    plot(mean(FFTData(:,:,3,2),1),'k');
    for count = 1:26
        hold on
        plot([count count],[-1 1], [':',tick_colours{count}]);
    end
    xlab = {'Wait', 'Wait','Instr','Instr','Instr','Wait','Wait','Wait','Hear','Hear','Hear','Hear','Wait','Recall','Recall','Recall','Recall','Wait','Recall','Recall','Recall','Recall','Wait','Wait','Wait','Wait'};
    xticks([1:26]); set(gca,'XTickLabel',xlab); xlim([0 27]); xtickangle(45);
end

%% Bar plot
sec_range = 12;

load('Participant_Pupil.mat');
figure('rend','painters','pos',[10 10 1400 800])
Bar_P = squeeze(mean(mean(pupil(:,sec_range,1:2),2),1));
ci_P = squeeze(tinv(0.95,28).*(std(mean(pupil(:,sec_range,1:2),2))/sqrt(29)));
[h_p,p_p,ci_p,stats_p] = ttest(squeeze(mean(pupil(:,sec_range,2),2)),squeeze(mean(pupil(:,sec_range,1),2)));
d_p = mean(squeeze(mean(pupil(:,sec_range,2),2))-squeeze(mean(pupil(:,sec_range,1),2)))/std(squeeze(mean(pupil(:,sec_range,2),2))-squeeze(mean(pupil(:,sec_range,1),2)));
subplot(1,3,1)
bar(1:2,Bar_P);
hold on
errorbar(1:2,Bar_P,ci_P,'linestyle', 'none','linewidth',2);
xticklabels({ 'Add-Zero', 'Add-One'});
ylabel('Pupil Diameter');
t= text(.7,3.9,['t(28) = ', num2str(stats_p.tstat), ', p = ',num2str(p_p), ', d = ', num2str(d_p)]);
t.Color = 'red';
t.FontSize = 12;
 
Bar_T = mean(squeeze(mean(FFTData(:,sec_range,1:2,1),2)),1);
Temp_T = squeeze(mean(FFTData(:,sec_range,1:2,1),2));
T_Diff = Temp_T(:,2)-Temp_T(:,1);
ci_TD = squeeze(tinv(0.95,28).*(std(T_Diff)/sqrt(29)));
% outdata1 = squeeze(mean(FFTData(:,sec_range,1:2,1),2));
% outsd1 = std(outdata);
% outd1 = (outdata - Bar_T)./outsd
% outdata2 = squeeze(mean(FFTData(:,sec_range,1:2,2),2));
% outsd2 = std(outdata);
% outd2 = (outdata - Bar_T)./outsd

ci_T = tinv(0.95,28).*(std(squeeze(mean(FFTData(:,sec_range,1:2,1),2)))/sqrt(29));
[h_t,p_t,ci_t,stats_t] = ttest(squeeze(mean(FFTData(:,sec_range,2,1),2)),squeeze(mean(FFTData(:,sec_range,1,1),2)));
d_t = mean(squeeze(mean(FFTData(:,sec_range,2,1),2))-squeeze(mean(FFTData(:,sec_range,1,1),2)))/std(squeeze(mean(FFTData(:,sec_range,2,1),2))-squeeze(mean(FFTData(:,sec_range,1,1),2)));
subplot(1,3,2)
bar(1:2,Bar_T);
hold on
errorbar(1:2,Bar_T,ci_T,'linestyle', 'none','linewidth',2);
xticklabels({ 'Add-Zero', 'Add-One'});
ylabel('Theta Power');
t= text(.8,-.38,['t(28) = ', num2str(stats_t.tstat), ', p = ',num2str(p_t), ', d = ', num2str(d_t)]);
t.Color = 'red';
t.FontSize = 12;

Bar_A = mean(squeeze(mean(FFTData(:,sec_range,1:2,2),2)),1);
Temp_A = squeeze(mean(FFTData(:,sec_range,1:2,2),2));
A_Diff = Temp_A(:,2)-Temp_A(:,1);
ci_AD = squeeze(tinv(0.95,28).*(std(A_Diff)/sqrt(29)));

ci_A = tinv(0.95,28).*(std(squeeze(mean(FFTData(:,sec_range,1:2,2),2)))/sqrt(29));
[h_a,p_a,ci_a,stats_a] = ttest(squeeze(mean(FFTData(:,sec_range,2,2),2)),squeeze(mean(FFTData(:,sec_range,1,2),2)));
d_a = mean(squeeze(mean(FFTData(:,sec_range,2,2),2))-squeeze(mean(FFTData(:,sec_range,1,2),2)))/std(squeeze(mean(FFTData(:,sec_range,2,2),2))-squeeze(mean(FFTData(:,sec_range,1,2),2)));
subplot(1,3,3)
bar(1:2,Bar_A);
hold on
errorbar(1:2,Bar_A,ci_A,'linestyle', 'none','linewidth',2);
xticklabels({ 'Add-Zero', 'Add-One'});
ylabel('Alpha Power');
t= text(0+.8,-.78,['t(28) = ', num2str(stats_a.tstat), ', p = ',num2str(p_a), ', d = ', num2str(d_a)]);
t.Color = 'red';
t.FontSize = 12;


%% Scatter
figure('rend','painters','pos',[10 10 1400 800])
subplot(1,3,1)
scatter(Pupil_Data(3,:),mean(FFTData(:,:,3,1),1));
hold on
fit = polyfit(Pupil_Data(3,:),mean(FFTData(:,:,3,1),1),1);
range = min(Pupil_Data(3,:)):.01:max(Pupil_Data(3,:));
plot_fit = polyval(fit,range);
plot(range, plot_fit, 'r-', 'LineWidth', 2);
xlabel('Pupil Size', 'FontSize', 14);
ylabel('Theta', 'FontSize', 14);
ylim=get(gca,'ylim');
xlim=get(gca,'xlim');
cor1 = corrcoef(Pupil_Data(3,:),mean(FFTData(:,:,3,1),1));
t= text(0+.1,1-.1,['r(24) = ' num2str(num2str(cor1(2))), ', p = .0001']);
t.Color = 'red';
t.FontSize = 12;

subplot(1,3,2)
scatter(Pupil_Data(3,:),mean(FFTData(:,:,3,2),1));
hold on
fit = polyfit(Pupil_Data(3,:),mean(FFTData(:,:,3,2),1),1);
range = min(Pupil_Data(3,:)):.01:max(Pupil_Data(3,:));
plot_fit = polyval(fit,range);
plot(range, plot_fit, 'r-', 'LineWidth', 2);
xlabel('Pupil Size', 'FontSize', 14);
ylabel('Alpha', 'FontSize', 14);
ylim=get(gca,'ylim');
xlim=get(gca,'xlim');
cor2 = corrcoef(Pupil_Data(3,:),mean(FFTData(:,:,3,2),1));
t= text(0+.1,.58,['r(24) = ' num2str(num2str(cor2(2))), ', p = .0015']);
t.Color = 'red';
t.FontSize = 12;

subplot(1,3,3)
scatter(mean(FFTData(:,:,3,1),1),mean(FFTData(:,:,3,2),1));
hold on
fit = polyfit(mean(FFTData(:,:,3,1),1),mean(FFTData(:,:,3,2),1),1);
range = min(mean(FFTData(:,:,3,1),1)):.01:max(mean(FFTData(:,:,3,1),1));
plot_fit = polyval(fit,range);
plot(range, plot_fit, 'r-', 'LineWidth', 2);
xlabel('Theta', 'FontSize', 14);
ylabel('Alpha', 'FontSize', 14);
ylim=get(gca,'ylim');
xlim=get(gca,'xlim');
cor3 = corrcoef(mean(FFTData(:,:,3,1),1),mean(FFTData(:,:,3,2),1));
t= text(0+.1,.58,['r(24) = ' num2str(num2str(cor3(2))), ', p = .2413']);
t.Color = 'red';
t.FontSize = 12;

%Variables for extraction
MeanDiff = FFTData(:,:,2) - FFTData(:,:,1);
MeanFFT = mean(MeanDiff,1);